Public Member Functions | Data Fields

# QueryWindow Struct Reference

Window used for asking the user a YES/NO question. More...

Inheritance diagram for QueryWindow:

## Public Member Functions
| QueryWindow (const WindowDesc *desc, StringID caption, StringID message, Window *parent, QueryCallbackProc *callback)
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual EventState | OnKeyPress (uint16 key, uint16 keycode)
| A key has been pressed.
## Data Fields
QueryCallbackProc * | proc
| callback function executed on closing of popup. Window* points to parent, bool is true if 'yes' clicked, false otherwise
uint64 | params [10]
| local copy of _decode_parameters
StringID | message
| message shown for query window
StringID | caption
| title of window

## Detailed Description

Window used for asking the user a YES/NO question.

Definition at line 987 of file misc_gui.cpp.

## Member Function Documentation

virtual void QueryWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1038 of file misc_gui.cpp.

References DrawStringMultiLine(), SA_CENTER, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_TOP, WD_FRAMETEXT_LEFT, WD_FRAMETEXT_RIGHT, and WID_Q_TEXT.

virtual void QueryWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1046 of file misc_gui.cpp.

References Window::parent, proc, WID_Q_NO, and WID_Q_YES.

virtual EventState QueryWindow::OnKeyPress | ( | uint16 | key,
|  | uint16 | keycode |
| ) |  |  | `[inline, virtual]`

A key has been pressed.

Parameters:

  | key | the Unicode value of the key.
  | keycode | the untranslated key code including shift state.

Returns:
  ES_HANDLED if the key press has been handled and no other window should receive the event.

Reimplemented from Window.

Definition at line 1069 of file misc_gui.cpp.

References Window::parent, and proc.

virtual void QueryWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 1014 of file misc_gui.cpp.

References caption, CopyInDParam(), lengthof, params, SetDParam(), WID_Q_CAPTION, and WID_Q_TEXT.

virtual void QueryWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 1028 of file misc_gui.cpp.

References GetStringMultiLineBoundingBox(), message, WD_FRAMERECT_TOP, WD_FRAMETEXT_LEFT, and WID_Q_TEXT.

The documentation for this struct was generated from the following file:

- src/misc_gui.cpp